package mysqlbug;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
//import java.util.Random;

public class InserterThread extends Thread {

	private int _tid;
	private int _count = 0;
//	private Random _random;

	public InserterThread(int tid) {
		_tid = tid;	// thread id
//		_random = new Random( System.currentTimeMillis() );
	}
	
	@Override
	public void run() {
		try {
			Connection c = DB.getInstance().getConnection();
			System.out.println("Thread " + _tid + " Connected.");
			PreparedStatement psdoc = c.prepareStatement("INSERT INTO document (dockey) VALUES (?)");
			PreparedStatement psdocid = c.prepareStatement("SELECT docid FROM document WHERE dockey=?");
			PreparedStatement psdelete = c.prepareStatement("DELETE FROM field WHERE docid=?");
			PreparedStatement psfield = c.prepareStatement("INSERT INTO field (docid,field_name,field_string) VALUES (?,?,?)");
			
			while(true) {
				c.setAutoCommit(false);
				
				// create Document
				String dockey = "T" + _tid + "Doc" + ++_count;
				psdoc.setString(1, dockey);
				psdoc.executeUpdate();
				
				
				// create Fields
				int docid = 0;
				psdocid.setString(1, dockey);
				ResultSet rs = psdocid.executeQuery();
				if( rs.next() ) {
					docid = rs.getInt("docid");
				}
				if( docid > 0 ) {

					// >> THIS COMMAND IS WHAT BRINGS UP THE DEADLOCK <<
					// delete old fields (none in this simplistic code, but in application code, a Document's fields are "updated" by deleting old ones and inserting new ones)
					psdelete.setInt(1, docid);
					psdelete.execute();

					psfield.setInt(1, docid);
					for(int k = 1; k <= 5; k++) {
						psfield.setString(2, "field" + k);
						psfield.setString(3, "value" + k);
						psfield.addBatch();
					}
					psfield.executeBatch();
				} else {
					throw new RuntimeException("Could not obtain docid");
				}
//				Thread.sleep( 0L, (int) sleepInterval() );
				c.commit();
			}
			// end of eternal loop
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	// sleep in time that is within 10 milliseconds
//	private long sleepInterval() {
//		return Math.abs( _random.nextLong() % 2500L );
//	}
}
